#include <stdio.h>
#include <stdlib.h>

// C passes arguments "by value" (not by "reference")
// This means that the function "increment" 
// gets the value of "x" when it is called
// as a copy. What will this program print?
void
increment(int x) { // int 'y' is a new variable somewhere in memory
    x = x + 3;     // y has its own address (different than x)
    printf("%d %p\n", x, &x); 
}

int
main(int argc, char *argv[])
{
    int x = 3;            // stack-allocated memory
    printf("%d %p\n", x, &x);   
    increment(x);
    printf("%d %p\n", x, &x);
    return 0;
}

// option 1
// 3
// 6
// 6
//
// option 2
// 3
// 6
// 3 

