#include <stdio.h>
#include <stdlib.h>

typedef struct node node_t;

struct node {
    int     key;
    node_t *next;
};

node_t *head = NULL;

void List_Insert(int key) {
    node_t *tmp = malloc(sizeof(node_t));
    tmp->key   = key;
    tmp->next  = head;
    head       = tmp;
}

void List_Delete(int key) {
    if (head == NULL) 
	return;
    if (head->key == key) {
	node_t *tmp = head;
	head = head->next;
	free(tmp);
    } else {
	node_t *prev = head;
	node_t *curr = head->next;
	while (curr) {
	    if (curr->key == key) {
		node_t *tmp = curr;
		prev->next  = curr->next;
		free(tmp);
		return; // just delete one instance of key
	    }
	    prev = curr;
	    curr = curr->next;
	}
    }
}

void List_Print() {
    node_t *tmp = head;
    printf("List: ");
    while (tmp) {
	printf("%d ", tmp->key);
	tmp = tmp->next;
    }
    printf("\n");
}


int
main(int argc, char *argv[])
{
    List_Delete(1);
    List_Insert(1);
    List_Insert(2);
    List_Insert(3);
    List_Print();	
    List_Delete(3);
    List_Print();	
    List_Delete(1);
    List_Print();	
    List_Delete(2);
    List_Print();	
    List_Delete(1);
    return 0;
}

